unit formworld;

// licence: absolutly free, no guarantees!

{$mode objfpc}{$H+}

interface

uses
  {$IFDEF FPC}
  LCLIntf, LResources,
  {$ENDIF}
  Classes, SysUtils, eventlog, FileUtil, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Spin, Buttons, ComCtrls, ActnList, uthreadworld;

type

  { Tfrm_god }

  Tfrm_god = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lb_lifes: TLabel;
    mm_world: TMemo;
    Panel1:TPanel;
    Label1:TLabel;
    btn_newLife:TButton;
    btn_fire:TButton;
    btn_terminate:TButton;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    pb_resources: TProgressBar;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    procedure btn_fireClick(Sender: TObject);
    procedure btn_newLifeClick(Sender: TObject);
    procedure btn_terminateClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure showStatus(Sender:TObject; aStatus:string);
  private
    FWorld: TWorld;
  public
    { public declarations }
  end; 

var
  frm_god: Tfrm_god;

implementation

{ Tfrm_god }

procedure Tfrm_god.FormCreate(Sender: TObject);
begin
  FWorld := TWorld.create(self);
  FWorld.onStatus := @showStatus;
  FWorld.Resources := 1000;
  pb_Resources.Max := FWorld.Resources;
  timer1.enabled := true;
end;

procedure Tfrm_god.FormDestroy(Sender: TObject);
begin
  freeAndNil(FWorld);
end;

// show thread data
procedure Tfrm_god.Timer1Timer(Sender: TObject);
begin
  if FWorld = nil then
     exit;
  Timer1.enabled := false;
  try
    while FWorld.Locked do // prevent overload
       Application.processMessages;
      mm_World.lines.clear;
      mm_World.lines.text := FWorld.View;
      lb_lifes.caption := IntToStr(FWorld.ThreadsRunning);
      pb_resources.position := FWorld.Resources;
  finally
    Timer1.enabled := true;
    Application.processMessages
  end;
end;

procedure Tfrm_god.showStatus(Sender: TObject; aStatus: string);
begin
  Statusbar1.SimpleText := aStatus;
end;

procedure Tfrm_god.btn_newLifeClick(Sender: TObject);
begin
  while FWorld.Locked do // prevent overload
     Application.processMessages;
  if not timer1.enabled then
     timer1.enabled := true;
  FWorld.newLife;
end;

procedure Tfrm_god.btn_fireClick(Sender: TObject);
begin
  while FWorld.Locked do // prevent overload
     Application.processMessages;
  // other possibility:
  // if FWorld.Locked then
  //    exit;
  FWorld.fire;
end;

procedure Tfrm_god.btn_terminateClick(Sender: TObject);
begin
  Statusbar1.simpleText := ('Wait ...');
  Application.processMessages;
  FWorld.terminateAllLifes;
  Statusbar1.simpleText := ('');
  FWorld.Resources := 1000;
end;

procedure Tfrm_god.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  timer1.enabled := false;
  btn_terminateClick(nil);
end;

initialization
  {$I formworld.lrs}
end.

